package com.totopia.server.modules.user.entity;

import com.totopia.server.commons.data.entity.UserDateAuditEntity;
import lombok.experimental.SuperBuilder;

import javax.persistence.*;

@Entity(name = "bank_account")
@SuperBuilder
public class BankAccountEntity extends UserDateAuditEntity {

  private static final long serialVersionUID = -8628291684559836128L;

  @Id
  @GeneratedValue(generator = "bank_account_generator")
  @SequenceGenerator(name = "bank_account_generator", sequenceName = "bank_account_sequence", initialValue = 1)
  private Long id;

  @Basic
  @Column(name = "name", nullable = false, length = 100)
  private String name;

  @Basic
  @Column(name = "number", nullable = false, length = 100)
  private String number;

  @Basic
  @Column(name = "holder", nullable = false, length = 100)
  private String holder;

  @Basic
  @Column(name = "username", nullable = false)
  private String username;

  public BankAccountEntity(Long id, String name, String number, String holder, String username) {
    this.id = id;
    this.name = name;
    this.number = number;
    this.holder = holder;
    this.username = username;
  }

  public BankAccountEntity() {
  }

  public Long getId() {
    return this.id;
  }

  public String getName() {
    return this.name;
  }

  public String getNumber() {
    return this.number;
  }

  public String getHolder() {
    return this.holder;
  }

  public String getUsername() {
    return this.username;
  }

  public void setId(Long id) {
    this.id = id;
  }

  public void setName(String name) {
    this.name = name;
  }

  public void setNumber(String number) {
    this.number = number;
  }

  public void setHolder(String holder) {
    this.holder = holder;
  }

  public void setUsername(String username) {
    this.username = username;
  }

  public String toString() {
    return "BankAccountEntity(id=" + this.getId() + ", name=" + this.getName() + ", number=" + this.getNumber() + ", holder=" + this.getHolder() + ", username=" + this.getUsername() + ")";
  }

  public boolean equals(final Object o) {
    if (o == this) return true;
    if (!(o instanceof BankAccountEntity)) return false;
    final BankAccountEntity other = (BankAccountEntity) o;
    if (!other.canEqual((Object) this)) return false;
    final Object this$id = this.getId();
    final Object other$id = other.getId();
    if (this$id == null ? other$id != null : !this$id.equals(other$id)) return false;
    final Object this$name = this.getName();
    final Object other$name = other.getName();
    if (this$name == null ? other$name != null : !this$name.equals(other$name)) return false;
    final Object this$number = this.getNumber();
    final Object other$number = other.getNumber();
    if (this$number == null ? other$number != null : !this$number.equals(other$number)) return false;
    final Object this$holder = this.getHolder();
    final Object other$holder = other.getHolder();
    if (this$holder == null ? other$holder != null : !this$holder.equals(other$holder)) return false;
    final Object this$username = this.getUsername();
    final Object other$username = other.getUsername();
    if (this$username == null ? other$username != null : !this$username.equals(other$username)) return false;
    return true;
  }

  protected boolean canEqual(final Object other) {
    return other instanceof BankAccountEntity;
  }

  public int hashCode() {
    final int PRIME = 59;
    int result = 1;
    final Object $id = this.getId();
    result = result * PRIME + ($id == null ? 43 : $id.hashCode());
    final Object $name = this.getName();
    result = result * PRIME + ($name == null ? 43 : $name.hashCode());
    final Object $number = this.getNumber();
    result = result * PRIME + ($number == null ? 43 : $number.hashCode());
    final Object $holder = this.getHolder();
    result = result * PRIME + ($holder == null ? 43 : $holder.hashCode());
    final Object $username = this.getUsername();
    result = result * PRIME + ($username == null ? 43 : $username.hashCode());
    return result;
  }
}
