package com.totopia.server.modules.user.entity;

import com.totopia.server.modules.user.type.RoleName;

import javax.persistence.*;
import java.io.Serializable;

@Entity(name = "roles")
public class RoleEntity implements Serializable {
  private static final long serialVersionUID = 5100719044067326295L;

  @Id
  @GeneratedValue(generator = "role_generator")
  @SequenceGenerator(name = "role_generator", sequenceName = "role_sequence", initialValue = 1)
  private Short id;

  @Enumerated(EnumType.STRING)
  @Column(name = "name", length = 60)
  private RoleName name;

  public RoleEntity(Short id, RoleName name) {
    this.id = id;
    this.name = name;
  }

  public RoleEntity() {
  }

  public static RoleEntityBuilder builder() {
    return new RoleEntityBuilder();
  }

  public Short getId() {
    return this.id;
  }

  public RoleName getName() {
    return this.name;
  }

  public void setId(Short id) {
    this.id = id;
  }

  public void setName(RoleName name) {
    this.name = name;
  }

  public boolean equals(final Object o) {
    if (o == this) return true;
    if (!(o instanceof RoleEntity)) return false;
    final RoleEntity other = (RoleEntity) o;
    if (!other.canEqual((Object) this)) return false;
    final Object this$id = this.getId();
    final Object other$id = other.getId();
    if (this$id == null ? other$id != null : !this$id.equals(other$id)) return false;
    final Object this$name = this.getName();
    final Object other$name = other.getName();
    if (this$name == null ? other$name != null : !this$name.equals(other$name)) return false;
    return true;
  }

  protected boolean canEqual(final Object other) {
    return other instanceof RoleEntity;
  }

  public int hashCode() {
    final int PRIME = 59;
    int result = 1;
    final Object $id = this.getId();
    result = result * PRIME + ($id == null ? 43 : $id.hashCode());
    final Object $name = this.getName();
    result = result * PRIME + ($name == null ? 43 : $name.hashCode());
    return result;
  }

  public String toString() {
    return "RoleEntity(id=" + this.getId() + ", name=" + this.getName() + ")";
  }

  public static class RoleEntityBuilder {
    private Short id;
    private RoleName name;

    RoleEntityBuilder() {
    }

    public RoleEntity.RoleEntityBuilder id(Short id) {
      this.id = id;
      return this;
    }

    public RoleEntity.RoleEntityBuilder name(RoleName name) {
      this.name = name;
      return this;
    }

    public RoleEntity build() {
      return new RoleEntity(id, name);
    }

    public String toString() {
      return "RoleEntity.RoleEntityBuilder(id=" + this.id + ", name=" + this.name + ")";
    }
  }
}
